#include <SDL/SDL.h>
#include <SDL/SDL_mixer.h>
#include "shippy.h"

SDL_Surface *screen = NULL;
SDL_Surface *BackBuffer = NULL;
SDL_Surface *Graphics = NULL;
Uint8 key[1337];

Uint32 CLEARCOLOR = 0;
SDL_Rect src;
SDL_Rect dest;

int jdirx=0;
int jdiry=0;
int jaction=0;
int jsecond=0;
int waitforkey=360;

volatile int objectsynch = 0;
Uint32 timing;

// SEB
int volume = 20;
int first_vol = 1;
SDL_Joystick *joystick;
#define GP2X_BUTTON_UP              (0)
#define GP2X_BUTTON_DOWN            (4)
#define GP2X_BUTTON_LEFT            (2)
#define GP2X_BUTTON_RIGHT           (6)
#define GP2X_BUTTON_UPLEFT          (1)
#define GP2X_BUTTON_UPRIGHT         (7)
#define GP2X_BUTTON_DOWNLEFT        (3)
#define GP2X_BUTTON_DOWNRIGHT       (5)
#define GP2X_BUTTON_CLICK           (18)
#define GP2X_BUTTON_A               (12)
#define GP2X_BUTTON_B               (13)
#define GP2X_BUTTON_X               (15)
#define GP2X_BUTTON_Y               (14)
#define GP2X_BUTTON_L               (11)
#define GP2X_BUTTON_R               (10)
#define GP2X_BUTTON_START           (8)
#define GP2X_BUTTON_SELECT          (9)
#define GP2X_BUTTON_VOLUP           (16)
#define GP2X_BUTTON_VOLDOWN         (17)

#define SNES_B 1
#define SNES_Y 3
#define SNES_UP 12
#define SNES_LEFT 13
#define SNES_DOWN 14
#define SNES_RIGHT 15
#define SNES_START 6
#define SNES_SELECT 7

#ifdef GP2X
    #define KEY_UP      GP2X_BUTTON_UP
    #define KEY_LEFT    (KEY_UP+2)
    #define KEY_DOWN    (KEY_UP+4)
    #define KEY_RIGHT   (KEY_UP+6)
    #define KEY_ACTION  GP2X_BUTTON_A
    #define KEY_SECOND  GP2X_BUTTON_START
    #define KEY_QUIT    GP2X_BUTTON_SELECT
#else
    #define KEY_UP      SNES_UP
    #define KEY_LEFT    (KEY_UP+1)
    #define KEY_DOWN    (KEY_UP+2)
    #define KEY_RIGHT   (KEY_UP+3)
    #define KEY_ACTION  SNES_Y
    #define KEY_SECOND  SNES_START
    #define KEY_QUIT    SNES_SELECT
#endif



// ~SEB

#define MAX_SAMPLES 8
SDL_Surface *CreateSurfaceFromBitmap(char *bmpfile,Uint32 flags)
{

    SDL_Surface *junktemp;
    SDL_Surface *junktemp2;

    junktemp=SDL_LoadBMP(bmpfile);

    junktemp2=SDL_ConvertSurface(junktemp, junktemp->format,flags);
    SDL_FreeSurface(junktemp);

    junktemp=SDL_DisplayFormat(junktemp2);
    SDL_FreeSurface(junktemp2);

    return junktemp;
}

int audio_op=0;
Mix_Music *music=NULL;

struct SAMPLEHOLDER
{
    int loaded;
    char samplename[512];
    Mix_Chunk *sample;
    int voice;
    int counter;
    int istaken;
};

struct SAMPLEHOLDER samples[MAX_SAMPLES];
int audio_op;
void Start_Audio()
{
    int i;
    audio_op=0;
    for(i=0;i<MAX_SAMPLES;++i)
    {
        samples[i].loaded=0;
        samples[i].samplename[0]=0;
        samples[i].sample=NULL;
        samples[i].voice=-1;
        samples[i].counter=0;
        samples[i].istaken=0;
    }
    music = NULL;
}


void audio_start()
{
// SEB
    //if(Mix_OpenAudio(MIX_DEFAULT_FREQUENCY, MIX_DEFAULT_FORMAT , 2, 2048)!=0) audio_op = 0;
    if(Mix_OpenAudio(MIX_DEFAULT_FREQUENCY, MIX_DEFAULT_FORMAT , 2, 512)!=0) audio_op = 0;
    else audio_op = 1;
// ~SEB
}

void audio_play(char *wav)
{
    //check to see if the sample is loaded
    int i;
    if(audio_op==0) return;
    for(i=0;i<MAX_SAMPLES;++i)
    {
        if(samples[i].istaken==0)
        {
            samples[i].sample = Mix_LoadWAV(wav);
            strcpy(samples[i].samplename,wav);
            samples[i].voice = Mix_PlayChannel(-1, samples[i].sample, 0);
            samples[i].loaded = 1;
            samples[i].istaken=1;
            ++samples[i].counter;
            return;
        }
    }
}

void audio_music(char *mfile)
{
    if(audio_op==0) return;

    if(music!=NULL)
    {
        Mix_FreeMusic(music);
    }
    music=Mix_LoadMUS(mfile);
    if(!music)
    {
        printf("Mix_LoadMUS(%s): %s\n", mfile,Mix_GetError());
        audio_op = 0;
    }
    else if(Mix_PlayMusic(music, -1)==-1)
    {
        printf("Mix_PlayMusic: %s\n", Mix_GetError());
    }
    // well, there's no music, but most games don't break without music...
}

void audio_exec()
{
    int i;
    if(audio_op==0) return;
    for(i=0;i<MAX_SAMPLES;++i)
    {
        if(samples[i].istaken)
        {
            if(samples[i].loaded==1)
            {
                if(Mix_Playing(samples[i].voice)==0)
                {
                    --samples[i].counter;
                    if(samples[i].counter<=0)
                    {
                        Mix_HaltChannel(samples[i].voice);
                        samples[i].voice = -1;
                        Mix_FreeChunk(samples[i].sample);
                        samples[i].sample=NULL;
                        samples[i].istaken=0;
                    }
                    samples[i].loaded=0;
                }
            }
        }
    }
}

void audio_end()
{
    int i;
    audio_op = 0;
    for(i=0;i<MAX_SAMPLES;++i)
    {
        if(samples[i].istaken==1)
        {
            Mix_HaltChannel(samples[i].voice);
            samples[i].voice = -1;
            Mix_FreeChunk(samples[i].sample);
        }
    }
}


void End_Audio()
{
    Mix_HaltMusic();
    Mix_CloseAudio();
    audio_end();
}



int done = 0;
int gscale = 1;


void SYSTEM_CLEANBMP()
{
    if(BackBuffer!=NULL) SDL_FreeSurface(BackBuffer);
    if(Graphics!=NULL) SDL_FreeSurface(Graphics);
    BackBuffer=NULL;
    Graphics=NULL;
}


void SYSTEM_SETVID()
{
// SEB
    screen = SDL_SetVideoMode(320, 240, 16, SDL_SWSURFACE | SDL_HWPALETTE);
    joystick = SDL_JoystickOpen(0);
    SDL_ShowCursor(SDL_DISABLE);
// ~SEB
    if ( screen == NULL )
    {
        return;
    }

    SYSTEM_CLEANBMP();

    Graphics = CreateSurfaceFromBitmap("data/graphics.bmp",SDL_SWSURFACE|SDL_SRCCOLORKEY);
    BackBuffer= CreateSurfaceFromBitmap("data/splash.bmp",SDL_SWSURFACE|SDL_SRCCOLORKEY);
// SEB
    //SDL_SetColors(screen, Graphics->format->palette->colors, 0,Graphics->format->palette->ncolors);
// ~SEB
    SDL_SetColorKey(Graphics,SDL_SRCCOLORKEY, SDL_MapRGB(Graphics->format, 255, 0, 255));
    SDL_SetColorKey(BackBuffer,SDL_SRCCOLORKEY, SDL_MapRGB(Graphics->format, 255, 0, 255));
    SDL_SetClipRect(screen, NULL);
    SDL_FillRect(BackBuffer, NULL, CLEARCOLOR);
    CLEARCOLOR = SDL_MapRGB(Graphics->format, 0, 0, 0);
}


int SYSTEM_INIT()
{

    if((SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO|SDL_INIT_JOYSTICK)==-1))
    {
        return 1;
    }
    timing = SDL_GetTicks();

    atexit(SDL_Quit);
    SYSTEM_SETVID();
    SDL_WM_SetCaption("Shippy1984 by Ryan Broomfield SDL VERSION", NULL);

    audio_start();

    return 0;
}

int SYSTEM_CLEAN()
{
    SYSTEM_CLEANBMP();
    End_Audio();
// SEB
    SDL_JoystickClose(joystick);
// ~SEB
    return 0;
}

int SYSTEM_GETKEY(int scancode)
{
    return 0;

}

int SYSTEM_BG(char *bmp)
{
    if(BackBuffer!=NULL) SDL_FreeSurface(BackBuffer);
    BackBuffer= CreateSurfaceFromBitmap(bmp,SDL_SWSURFACE|SDL_SRCCOLORKEY);
    if(BackBuffer==NULL) done=1;
    else SDL_SetColorKey(BackBuffer,SDL_SRCCOLORKEY, SDL_MapRGB(Graphics->format, 255, 0, 255));

}


/* NEW SYSTEM_FINISHRENDER() BY JONATHAN GILBERT 1-28-2004 */
int SYSTEM_FINISHRENDER()
{
  int x, y, w;
  Uint16 *in;
  Uint16 *out;

  if (SDL_MUSTLOCK(BackBuffer))
    SDL_LockSurface(BackBuffer);
  if (SDL_MUSTLOCK(screen))
    SDL_LockSurface(screen);

  in = (Uint16 *)BackBuffer->pixels;
  out = (Uint16 *)screen->pixels;

  w = BackBuffer->pitch;

// SEB
    SDL_Rect offset = {0,13,0,0};
    SDL_BlitSurface(BackBuffer, 0, screen, &offset);

//    for (y = 0; y < 160; y++) {
//        for (x = 0; x < 240; x++) {
//            short dot = *(short *)(in + x + y * 240);
//            *(short *)(out + 40+40*320 + y * 320 + x) = dot;
//        }
//    }

//  for (y=0; y<160; y++)
//  {
//    for (x=0; x<w; x += 2)
//    {
//      Uint32 sample = *(Uint16 *)&in[x];
//
//      sample = (sample & 0xFF) | (sample >> 8 << 16);
//      sample *= 257;
//
//      *(Uint32 *)(&out[x]) = sample;
//      *(Uint32 *)(&out[x + w]) = sample;
//    }
//
//    in += w;
//    out += w + w;
//  }

// ~SEB
  if (SDL_MUSTLOCK(BackBuffer))
    SDL_UnlockSurface(BackBuffer);
  if (SDL_MUSTLOCK(screen))
    SDL_UnlockSurface(screen);

  SDL_UpdateRect(screen, 0, 0, 0, 0);
}


int SYSTEM_CLEARSCREEN()
{
    if(SDL_FillRect(BackBuffer, NULL, CLEARCOLOR)==-1)
    {
        printf("CLS ERROR! \n");
    }
}

// SEB
#define SCALE(x) (x * 4) / 3
int SYSTEM_BLIT(int sx, int sy, int x, int y, int szx, int szy)
{
    src.x = SCALE(sx);
    src.y = SCALE(sy);
    src.w=SCALE(szx);
    src.h=SCALE(szy);
    dest.x=SCALE(x);
    dest.y=SCALE(y);
    dest.w=SCALE(szx);
    dest.h=SCALE(szy);
// ~SEB
    if(SDL_BlitSurface(Graphics,&src,BackBuffer,&dest)==-1)
    {
        printf("SYSTEM_BLIT ERROR! \n");
    }

}

void SYSTEM_POLLINPUT()
{
    int tx,ty;
    jaction = 0;
    jsecond = 0;
    jdirx = 0;
    jdiry = 0;


    if(key[KEY_QUIT]) done = 1;
    if(waitforkey>0)
    {
        --waitforkey;
        return;
    }

/*    if(num_joysticks>0)
    {
        poll_joystick();
        jaction = joy[0].button[0].b;
        jsecond = joy[0].button[1].b;
        jdirx = (joy[0].stick[0].axis[0].d1 - joy[0].stick[0].axis[0].d2)*2;
        jdiry = (joy[0].stick[0].axis[1].d1 - joy[0].stick[0].axis[1].d2);
    }
*/

    jdirx = 0;
    jdiry = 0;
    jaction = 0;
    jsecond = 0;

// SEB
//    if(jdirx == 0) jdirx=(key[SDLK_RIGHT] - key[SDLK_LEFT]) * 2;
//    if(jdiry == 0) jdiry=key[SDLK_DOWN] - key[SDLK_UP];
//    if(jaction == 0) jaction = key[SDLK_LCTRL];
//    if(jsecond == 0) jsecond = key[SDLK_BACKSPACE];

    if(jdirx == 0) jdirx=(key[KEY_RIGHT] - key[KEY_LEFT]) * 2;
    if(jdiry == 0) jdiry=key[KEY_DOWN] - key[KEY_UP];
    if(jaction == 0) jaction = key[KEY_ACTION];
    if(jsecond == 0) jsecond = key[KEY_SECOND];

#ifdef GP2X
    if (key[GP2X_BUTTON_VOLDOWN]) {
        volume--;
        if (volume < 0) volume = 0;
        Mix_Volume(-1, volume);
        Mix_VolumeMusic(volume);
    }
    if (key[GP2X_BUTTON_VOLUP]) {
        volume++;
        if (volume > 100) volume = 100;
        Mix_Volume(-1, volume);
        Mix_VolumeMusic(volume);
    }

    if (first_vol) {
        Mix_VolumeMusic(volume);
        Mix_Volume(-1, volume);
        first_vol = 0;
    }
#endif
// ~SEB
}

void SYSTEM_IDLE()
{
    Uint32 test = SDL_GetTicks();
    while(test>timing)
    {
        timing+=14;
        ++objectsynch;
    }

  SDL_Event event;
  /* Poll for events. SDL_PollEvent() returns 0 when there are no  */
  /* more events on the event queue, our while loop will exit when */
  /* that occurs.                                                  */
    while( SDL_PollEvent( &event ) )
    {
        /* We are only worried about SDL_KEYDOWN and SDL_KEYUP events */
        if(event.type==SDL_QUIT)
        {
            done=1;
        }
        if(event.type==SDL_KEYDOWN)
        {
            key[event.key.keysym.sym]=1;
        }
        if(event.type==SDL_KEYUP)
        {
            key[event.key.keysym.sym]=0;
        }

// SEB
        if (event.type == SDL_JOYBUTTONDOWN) {
            key[event.jbutton.button] = 1;
        #ifdef GP2X
            if (event.jbutton.button == GP2X_BUTTON_DOWNLEFT) {
                key[GP2X_BUTTON_DOWN] = 1;
                key[GP2X_BUTTON_LEFT] = 1;
            }
            if (event.jbutton.button == GP2X_BUTTON_DOWNRIGHT) {
                key[GP2X_BUTTON_DOWN] = 1;
                key[GP2X_BUTTON_RIGHT] = 1;
            }
            if (event.jbutton.button == GP2X_BUTTON_UPLEFT) {
                key[GP2X_BUTTON_UP] = 1;
                key[GP2X_BUTTON_LEFT] = 1;
            }
            if (event.jbutton.button == GP2X_BUTTON_UPRIGHT) {
                key[GP2X_BUTTON_UP] = 1;
                key[GP2X_BUTTON_RIGHT] = 1;
            }
        #endif
        }
        if (event.type == SDL_JOYBUTTONUP) {
            key[event.jbutton.button] = 0;
        #ifdef GP2X
            if (event.jbutton.button == GP2X_BUTTON_DOWNLEFT) {
                key[GP2X_BUTTON_DOWN] = 0;
                key[GP2X_BUTTON_LEFT] = 0;
            }
            if (event.jbutton.button == GP2X_BUTTON_DOWNRIGHT) {
                key[GP2X_BUTTON_DOWN] = 0;
                key[GP2X_BUTTON_RIGHT] = 0;
            }
            if (event.jbutton.button == GP2X_BUTTON_UPLEFT) {
                key[GP2X_BUTTON_UP] = 0;
                key[GP2X_BUTTON_LEFT] = 0;
            }
            if (event.jbutton.button == GP2X_BUTTON_UPRIGHT) {
                key[GP2X_BUTTON_UP] = 0;
                key[GP2X_BUTTON_RIGHT] = 0;
            }
        #endif
        }
// ~SEB
    }

}

int main(int argc, char*argv[])
{

	SHIPPY_MAIN();

}
